/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO (Extended = ExtendedPersistenceContext ConversationScope (Group = EntityExtendedDAO.class)
 *
 */

package de.ivu.elect.business.datei.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.datei.entity.DateiExport;
import de.ivu.elect.jee.entity.ExtendedDAO;

@javax.enterprise.context.RequestScoped
public class DateiExportExtendedDAO extends AbstractDateiExportDAO implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  transient ExtendedDAO extendedDAO;

  @Inject
  transient de.ivu.elect.presentation.system.ExtendedDAORequestCache cache;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return extendedDAO.getEntityManager();
  }

  @Override
  public void flush() {
    extendedDAO.flush();
  }

  public void flushNewTransaction() {
    extendedDAO.flushNewTransaction();
  }

/**
* Name: DateiExportArtAndWahlOrderBeiErstellungszeitpunktDescNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT OBJECT(o) FROM DateiExport o WHERE o.dateiArt=?1 AND o.datei.wahl=?2 ORDER BY o.datei.erstellungszeitpunkt DESC<br>
* SQL: <br>
*/
@Override
public java.util.List<DateiExport> findByDateiExportArtAndWahlOrderBeiErstellungszeitpunktDesc( @javax.annotation.Nonnull de.ivu.elect.business.exchange.entity.DateiExportArt dateiArt,  @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  int limit) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("DateiExport.findByDateiExportArtAndWahlOrderBeiErstellungszeitpunktDesc" ,  dateiArt ,  wahl  ,  limit);

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByDateiExportArtAndWahlOrderBeiErstellungszeitpunktDesc(): Miss");
        }

        cache.put(key, super.findByDateiExportArtAndWahlOrderBeiErstellungszeitpunktDesc( dateiArt ,  wahl  ,  limit));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByDateiExportArtAndWahlOrderBeiErstellungszeitpunktDesc(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<DateiExport>) cache.lookup(key));
    }

    return super.findByDateiExportArtAndWahlOrderBeiErstellungszeitpunktDesc( dateiArt ,  wahl  ,  limit);
}
/**
* Name: DateiExportArtOrderBeiErstellungszeitpunktDescNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT OBJECT(o) FROM DateiExport o WHERE o.datei.mandant=?1 AND o.dateiArt=?2 ORDER BY o.datei.erstellungszeitpunkt DESC<br>
* SQL: <br>
*/
@Override
public java.util.List<DateiExport> findByDateiExportArtOrderBeiErstellungszeitpunktDesc( @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant,  @javax.annotation.Nonnull de.ivu.elect.business.exchange.entity.DateiExportArt dateiArt) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("DateiExport.findByDateiExportArtOrderBeiErstellungszeitpunktDesc" ,  mandant ,  dateiArt  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByDateiExportArtOrderBeiErstellungszeitpunktDesc(): Miss");
        }

        cache.put(key, super.findByDateiExportArtOrderBeiErstellungszeitpunktDesc( mandant ,  dateiArt  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByDateiExportArtOrderBeiErstellungszeitpunktDesc(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<DateiExport>) cache.lookup(key));
    }

    return super.findByDateiExportArtOrderBeiErstellungszeitpunktDesc( mandant ,  dateiArt  );
}

  @Override
  public void clear() {
    cache.clear();

    super.clear();
  }
}
